Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 1809931 - %mvn_install does not honour %_prefix
Summary: %mvn_install does not honour %_prefix
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: flatpak-rpm-macros
Version: 31
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Stephan Bergmann
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-03-04 08:49 UTC by Stephan Bergmann
Modified: 2020-03-20 00:16 UTC (History)
9 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-03-20 00:16:31 UTC
Type: Bug


Attachments (Terms of Use)

Description Stephan Bergmann 2020-03-04 08:49:41 UTC
Description of problem:

I discovered this when trying to do a flatpak build of LibreOffice following the instructions at <https://docs.fedoraproject.org/en-US/flatpak/>.  One component that needs to be rebuilt with %_prefix set to /app (instead of the usual /usr) is bsh, which uses %mvn_install (see <https://src.fedoraproject.org/rpms/bsh/blob/f31/f/bsh.spec>).

However, the spec file line

  %mvn_install -J javadoc

there apparently creates %{buildroot}/usr/share/java/bsh.jar (and records that in .mfiles) rather than %{buildroot}/app/share/java/bsh.jar, even if %_prefix is /app.


Version-Release number of selected component (if applicable):

$ rpm -qf /usr/lib/rpm/macros.d/macros.fjava
javapackages-local-5.3.0-6.fc31.noarch

Comment 1 Mikolaj Izdebski 2020-03-04 09:22:09 UTC
Value of _prefix macro is expanded during build of javapackages-tools and stored in configuration files (incl. /usr/share/xmvn/configuration.xml). Then these configuration files affect runtime of javapackages-tools and XMvn.
The recommended way to work with different prefix is to build javapackages-tools with desired prefix macro.
Another way is to provide custom configuration files for XMvn: https://fedora-java.github.io/xmvn/configuration.html

Comment 2 Stephan Bergmann 2020-03-18 09:03:59 UTC
(In reply to Mikolaj Izdebski from comment #1)
> Another way is to provide custom configuration files for XMvn:
> https://fedora-java.github.io/xmvn/configuration.html

See <https://src.fedoraproject.org/rpms/flatpak-rpm-macros/pull-request/3> "Resolves: rhbz#1809931 Let %xmvn_install store artifacts under /app".

Comment 3 Fedora Update System 2020-03-18 20:39:07 UTC
FEDORA-FLATPAK-2020-bbf5eaefb5 has been submitted as an update to Fedora 31 Flatpaks. https://bodhi.fedoraproject.org/updates/FEDORA-FLATPAK-2020-bbf5eaefb5

Comment 4 Fedora Update System 2020-03-19 02:28:50 UTC
flatpak-runtime-f31-3120200318190325.1, flatpak-sdk-f31-3120200318190325.1 has been pushed to the Fedora 31 Flatpaks testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-FLATPAK-2020-bbf5eaefb5

Comment 5 Fedora Update System 2020-03-20 00:16:31 UTC
flatpak-runtime-f31-3120200318190325.1, flatpak-sdk-f31-3120200318190325.1 has been pushed to the Fedora 31 Flatpaks stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.